#########
# check
#
# generate random strings:
#    startArea AB Sigma Syzygy PSL2 ST BQPD RL
#
# version info : 1.2.4  2022/10/24  H.Ogawa
#


from math import gcd
from random import randint

from .subprocedures import extGcd


def sA():
    return(str(randint(0,2))+'+-'[randint(0,1)])

def si(r):
    return(' '.join([' -'[randint(0,1)]+str(randint(1,2)) for k in range(r)]))

def sz(r):
    return(''.join([str(randint(0,2)) for k in range(r)]))

def ab(r):
    return('A'.join(['B'*randint(0,5) for k in range(r)]))

def psl2(r0):
    a,b = 0,0
    r = max(r0,5)
    while gcd(a, b) != 1:
        a,b = randint(0,r),randint(0,r)
    d,x,y = extGcd(a,b)
    return([[a,b], [x,y]])

def st(r):
    return('S'.join(['T'*randint(0,5) for k in range(r)]))

def bdpq(r):
    return(''.join(['bdpq'[randint(0,3)] for k in range(r)]))

def rl(r):
    return(''.join(['RLrl'[randint(0,3)] for k in range(r)]))


startArea = sA
Sigma = si
Syzygy = sz
AB = ab
PSL2 = psl2
ST = st
BQPD = bdpq
RL = rl

